package rdbtoonto.converters;

public class AroundOneTableLCS extends LocalConstraintSet {
	public String _Comment;
	public boolean _CommAllowed;
	
	public AroundOneTableLCS(String tbl) {
		super(tbl);
		_Comment = "-none-";
		_CommAllowed = true;
    }

	public AroundOneTableLCS(LocalConstraintSet cd) {
		super(cd._Table);

		_InstanceNamingPattern = cd._InstanceNamingPattern;
		_ClassName = cd._ClassName;
		_ColumnsToIgnore = cd._ColumnsToIgnore;
		
		_CommAllowed =true;
		_Comment = "-none-";
	}
	
	public boolean allActive() {
		return (super.allActive() && 
				(_CommAllowed || (_Comment.equals("-none-"))));
	}			
	
	public String toStringOpen() {
	    String str = super.toStringOpen();
		if (!_Comment.equals("-none-")) {
			String comm;
			if (_Comment.length() <= 20) {
				comm = _Comment;
			}
			else {
				comm = _Comment.substring(0,20) + " ...";
			}
	    	str += ", <b>Comment: </b><i>" + comm + "</i>";
	    }
		return str;
	}
	 
	public String toString() {
		String str = toStringOpen() + "]";
		return str;
	}

	
}