package rdbtoonto.dbmodel;


import java.io.*;
import java.lang.*;
import java.util.*;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;

import rdbtoonto.utils.Utilities;

/**
 * @author  scdtncf
 */
public class MSA_RDBDataHandler extends DefaultHandler {
	protected Database _Database;
	protected Table _Table;
	protected String _Cont;
	protected String _TableName;
	protected Set<String> _DefAtts;
	protected Vector<String> _FoundAtts;
	protected int _Depth;
	
	public MSA_RDBDataHandler(Database db, TableDef td) {
		_TableName = td._Name;
		_Database = db;
		_Table = new Table( td._Name);
		_Database.addTable(_Table);
		td.setTable(_Table);
		_Table.setTableDef(td);
		_DefAtts = td.getAttributeNames();
		_FoundAtts = new Vector<String>();
		_Depth = -1;
	}
	
	public void startDocument() {
//		System.out.println("Starting document parsing");
	}
	
	public void endDocument() {	
//		System.out.println("End of parse");
	}
	
	public void startElement(String uri,
			String localName,
			String qname,
			Attributes attl) {
		_Cont = "";
		_Depth++;
		}
	
	public void endElement(String uri,
			String localName,
			String qname) {
		
		String colName;
		colName = Utilities.normaliseName(localName);
		
		if (_Depth == 1) {
			addMissingValues();
			_FoundAtts = new Vector<String>();
		}
		else if (_Depth == 2) {
			_Table.addValue(colName,_Cont);
			_FoundAtts.add(colName);
		}
		_Depth--;
	}
	/*
	public void endElement(String uri,
			String localName,
			String qname) {
		String colName;
		colName = GenericMethods.normaliseName(localName);
		if (!(colName.equals(_TableName)) && 
			!(colName.equals("dataroot"))) {
			_Table.addValue(colName,_Cont);
			_FoundAtts.add(colName);
		}
		else if (colName.equals(_TableName)) {
			addMissingValues();
			_FoundAtts = new Vector<String>();
		}
	}
	*/
	public void addMissingValues() {
		String noCont ="";
		//	String noCont ="-o-";
		for(String att : _DefAtts) {
			if (!_FoundAtts.contains(att)) {
				_Table.addMissingValue(att,noCont);		
			}
		}
	}
	
	public void characters(char ch[], int start, int length) {
		
		//      if (_CurrEltName.equals("TERM")) {
		
		int end = start + length;
		
		for(int i = start; i < end ; i++) {
			_Cont += ch[i];   
		}
	}
	
	/*-----------------------------------------------------------------*/
	/* Error handling         */
	/*-----------------------------------------------------------------*/
	
	public void warning(SAXParseException e) throws SAXException {
		System.err.println("Warning ! line: " +  e.getLineNumber() + ", col : " + e.getColumnNumber() + " : " + e.getMessage());
	}
	
	public void error(SAXParseException e) throws SAXException {
		System.err.println("Error !  line: " + e.getLineNumber() + ", col " + e.getColumnNumber() + " : " + e.getMessage());
	}
	
	public void fatalError(SAXParseException e) throws SAXException {
		System.err.println("Fatal Error  ! line: " + e.getLineNumber() + ", col " + e.getColumnNumber() + " : " + e.getMessage());
	}
}


