package rdbtoonto.dbmodel;


import java.io.*;
import java.lang.*;
import java.util.*;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;

import rdbtoonto.utils.Utilities;


public class MSA_RDBRelationHandler extends DefaultHandler {
	protected DBSchema _RDBSchema;
	protected String _CurrEltName;
	protected String _LastElt;
	
	protected String _Cont;
	protected boolean _IsRelevant;
	protected String _Name;
	protected String _MainTable;
	protected String _MainField;
	protected String _ForeignTable;
	protected String _ForeignField;
	
	
	public MSA_RDBRelationHandler(DBSchema rdbs) {
		_RDBSchema = rdbs;
	}
	
	public DBSchema getDBSchema(){
		return _RDBSchema;
	}
	
	public void startDocument() {	}
	
	public void endDocument() {	}
	
	public void startElement(String uri,
			String localName,
			String qname,
			Attributes attl) {
		
		_Cont = "";
		if (localName.equals("R2OTMPRelations")) {
			_IsRelevant = true;
		}
		
	}
	
	public void endElement(String uri,
			String localName,
			String qname) {
		if (_IsRelevant) {
			if (localName.equals("Name")) {
				_Name = Utilities.normaliseName(_Cont);
			}
			else if (localName.equals("Main_Table")) {
				_MainTable = Utilities.normaliseName(_Cont);
				if (!_RDBSchema.isDefined(_MainTable)) {
					_IsRelevant = false;
				}
			}
			else if (localName.equals("Main_Field")) {
				_MainField = Utilities.normaliseName(_Cont);
			}
			else if (localName.equals("Foreign_Table")) {
				_ForeignTable = Utilities.normaliseName(_Cont);
				if (!_RDBSchema.isDefined(_ForeignTable)) {
					_IsRelevant = false;
				}
			}
			else if (localName.equals("Foreign_Field")) {
				_ForeignField = Utilities.normaliseName(_Cont);
			}
			else if ((localName.equals("R2OTMPRelations")) && _IsRelevant) {
				TableDef maintab =_RDBSchema.getTableDef(_MainTable);
				TableDef fortab =_RDBSchema.getTableDef(_ForeignTable);
				PrimaryKey pkey = new PrimaryKey(_MainField);
				maintab.getAttribute(_MainField).setIsPrimaryKey(true);			
				maintab.setPrimaryKey(pkey);
				Vector<PrimaryKey> pkeys = new Vector<PrimaryKey>();
				pkeys.add(pkey);
				
				Attribute fatt = fortab.getAttribute(_ForeignField);
				fatt.setIsForeignKey(true);
				ForeignKey fkey = new ForeignKey(_ForeignField,pkeys,maintab);
				fortab.addForeignKey(fkey);
				/*
				Relationship rel = new Relationship(
						_Name,
						maintab,
						pkey,
						fortab,
						fkey);
				
				_RDBSchema.addRelation(rel);
				 */
			}   
		}
	}
	
	public void characters(char ch[], int start, int length) {
		
		//      if (_CurrEltName.equals("TERM")) {
		
		int end = start + length;
		
		for(int i = start; i < end ; i++) {
			_Cont += ch[i];   
		}
		//  System.out.println("Lemme: " + _Lemme + " (" + start + ", " + length +")");
		// }
	}
	
	/*-----------------------------------------------------------------*/
	/* Error Handling            */
	/*-----------------------------------------------------------------*/
	
	public void warning(SAXParseException e) throws SAXException {
		System.err.println("Warning - line : " +  e.getLineNumber() + ", col : " + e.getColumnNumber() + " : " + e.getMessage());
	}
	
	public void error(SAXParseException e) throws SAXException {
		System.err.println("Error - line: " + e.getLineNumber() + ", col " + e.getColumnNumber() + " : " + e.getMessage());
	}
	
	public void fatalError(SAXParseException e) throws SAXException {
		System.err.println("Fatal Error - line: " + e.getLineNumber() + ", col " + e.getColumnNumber() + " : " + e.getMessage());
	}
}


