package rdbtoonto.gui;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.util.HashSet;

import javax.swing.JCheckBox;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import rdbtoonto.converters.AroundOneTableLCS;
import rdbtoonto.converters.LocalConstraintSet;

public class AroundOneTableGui_LCSEditPanel extends BaseLCSEditPanel {
	private static JTextArea _CommentField;
	private static JCheckBox _CommSW;

	public AroundOneTableGui_LCSEditPanel(LocalConstraintSet cd ) {
		super(cd);

		GridBagConstraints c = new GridBagConstraints();
		c.insets = new Insets( 2, 2, 2, 2 );

		c.anchor = GridBagConstraints.WEST;

		_CommSW = new JCheckBox("Comment" );
		c.gridx = 0;
		c.gridy=4;
		add(_CommSW,c);

		c.gridx = 1;
		_CommentField = new JTextArea();
		_CommentField.setLineWrap(true);
		_CommentField.setWrapStyleWord(true);

		_CommentField.setEditable(true);
		_CommentField.setPreferredSize( R2OGui.hugeField);
		add(_CommentField,c);
	}

	/*
	 * Note that displayInitValues is defined so that constraints defined by other converters can
	 * be edited. Only the common part the taken into account (through 
	 * the super.displayInitValues() call
	 *  
	 * @see rdbtoonto.gui.BaseConvDefPanel#displayInitValues()
	 */

	public void displayInitValues() {
		super.displayInitValues();
		if (_LCS != null) {
			AroundOneTableLCS aotcd;

			if (_LCS instanceof AroundOneTableLCS) {
				aotcd = (AroundOneTableLCS)_LCS;	
			}
			else{
				aotcd = new AroundOneTableLCS(_LCS);
			}
			_CommSW.setSelected(aotcd._CommAllowed);		
			_CommentField.setText(aotcd._Comment);
			_CommSW.setSelected(aotcd._CommAllowed);		
		}
	}

	public boolean getValuesFromGui() {
		if (_LCS == null) {
			if (_TableName.equals("-none-")) {
				return false;
			}
			else {
				_LCS = new AroundOneTableLCS(_TableName);
				LCSEditor._CurrDef = _LCS;
			}
		}
		boolean result = super.getValuesFromGui();
		if (result) {
			String comm = _CommentField.getText();
			boolean commP = _CommSW.isSelected();
			comm.trim();
			if (comm.equals("")) {
				comm ="-none-";
			}
			if (_LCS instanceof AroundOneTableLCS) {
				AroundOneTableLCS acd = (AroundOneTableLCS)_LCS;
			}
			else {
				_LCS = new AroundOneTableLCS(_LCS);
			}
			((AroundOneTableLCS)_LCS)._Comment =comm;
			((AroundOneTableLCS)_LCS)._CommAllowed =commP;
		}
		return result;
	}


	public boolean  fillSlots(String tabName) {	
		boolean res = super.fillSlots(tabName);

		if ((res) && (!BaseLCSEditPanel._TableName.equals("-none-"))) { 

			_CommentField.setText("-none-");
			_CommSW.setSelected(true);
			return true;
		}
		return false;
	}



}
